Three Measures in JavaScript

Using ApexCharts with JavaScript

This Three Measures example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: '2021',
      data: [
        {
          x: 'Unit tests',
          y: 62,
        },
        {
          x: 'Linting',
          y: 55,
        },
        {
          x: 'Type checks',
          y: 31,
        },
        {
          x: 'E2E tests',
          y: 24,
        },
        {
          x: 'Security scan',
          y: 18,
        },
      ],
    },
    {
      name: '2023',
      data: [
        {
          x: 'Unit tests',
          y: 74,
        },
        {
          x: 'Linting',
          y: 71,
        },
        {
          x: 'Type checks',
          y: 52,
        },
        {
          x: 'E2E tests',
          y: 39,
        },
        {
          x: 'Security scan',
          y: 37,
        },
      ],
    },
    {
      name: '2025',
      data: [
        {
          x: 'Unit tests',
          y: 88,
        },
        {
          x: 'Linting',
          y: 86,
        },
        {
          x: 'Type checks',
          y: 78,
        },
        {
          x: 'E2E tests',
          y: 58,
        },
        {
          x: 'Security scan',
          y: 64,
        },
      ],
    },
  ],
  chart: {
    type: 'dumbbell',
    height: 380,
  },
  colors: ['#93C5FD', '#3B82F6', '#1D4ED8'],
  title: {
    text: 'Share of teams running each stage in CI',
    align: 'left',
  },
  subtitle: {
    text: 'Three snapshots on one row. Only the two extremes are labelled.',
    align: 'left',
  },
  plotOptions: {
    bar: {
      dumbbell: {
        connector: {
          color: '#E5E7EB',
          opacity: 1,
        },
        dataLabels: {
          formatter: function (val) {
            return val + '%'
          },
        },
      },
    },
  },
  xaxis: {
    min: 0,
    max: 100,
    labels: {
      formatter: function (val) {
        return val + '%'
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Three Measures in Vue

Using ApexCharts with Vue

This Three Measures example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="dumbbell"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: '2021',
          data: [
            {
              x: 'Unit tests',
              y: 62,
            },
            {
              x: 'Linting',
              y: 55,
            },
            {
              x: 'Type checks',
              y: 31,
            },
            {
              x: 'E2E tests',
              y: 24,
            },
            {
              x: 'Security scan',
              y: 18,
            },
          ],
        },
        {
          name: '2023',
          data: [
            {
              x: 'Unit tests',
              y: 74,
            },
            {
              x: 'Linting',
              y: 71,
            },
            {
              x: 'Type checks',
              y: 52,
            },
            {
              x: 'E2E tests',
              y: 39,
            },
            {
              x: 'Security scan',
              y: 37,
            },
          ],
        },
        {
          name: '2025',
          data: [
            {
              x: 'Unit tests',
              y: 88,
            },
            {
              x: 'Linting',
              y: 86,
            },
            {
              x: 'Type checks',
              y: 78,
            },
            {
              x: 'E2E tests',
              y: 58,
            },
            {
              x: 'Security scan',
              y: 64,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'dumbbell',
          height: 380,
        },
        colors: ['#93C5FD', '#3B82F6', '#1D4ED8'],
        title: {
          text: 'Share of teams running each stage in CI',
          align: 'left',
        },
        subtitle: {
          text: 'Three snapshots on one row. Only the two extremes are labelled.',
          align: 'left',
        },
        plotOptions: {
          bar: {
            dumbbell: {
              connector: {
                color: '#E5E7EB',
                opacity: 1,
              },
              dataLabels: {
                formatter: function (val) {
                  return val + '%'
                },
              },
            },
          },
        },
        xaxis: {
          min: 0,
          max: 100,
          labels: {
            formatter: function (val) {
              return val + '%'
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Three Measures in Angular

Using ApexCharts with Angular

This Three Measures example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: '2021',
              data: [
                {
                  x: 'Unit tests',
                  y: 62,
                },
                {
                  x: 'Linting',
                  y: 55,
                },
                {
                  x: 'Type checks',
                  y: 31,
                },
                {
                  x: 'E2E tests',
                  y: 24,
                },
                {
                  x: 'Security scan',
                  y: 18,
                },
              ],
            },
            {
              name: '2023',
              data: [
                {
                  x: 'Unit tests',
                  y: 74,
                },
                {
                  x: 'Linting',
                  y: 71,
                },
                {
                  x: 'Type checks',
                  y: 52,
                },
                {
                  x: 'E2E tests',
                  y: 39,
                },
                {
                  x: 'Security scan',
                  y: 37,
                },
              ],
            },
            {
              name: '2025',
              data: [
                {
                  x: 'Unit tests',
                  y: 88,
                },
                {
                  x: 'Linting',
                  y: 86,
                },
                {
                  x: 'Type checks',
                  y: 78,
                },
                {
                  x: 'E2E tests',
                  y: 58,
                },
                {
                  x: 'Security scan',
                  y: 64,
                },
              ],
            },
          ],
          chart: {
            type: 'dumbbell',
            height: 380,
          },
          colors: ['#93C5FD', '#3B82F6', '#1D4ED8'],
          title: {
            text: 'Share of teams running each stage in CI',
            align: 'left',
          },
          subtitle: {
            text: 'Three snapshots on one row. Only the two extremes are labelled.',
            align: 'left',
          },
          plotOptions: {
            bar: {
              dumbbell: {
                connector: {
                  color: '#E5E7EB',
                  opacity: 1,
                },
                dataLabels: {
                  formatter: (val) => {
                    return val + '%'
                  },
                },
              },
            },
          },
          xaxis: {
            min: 0,
            max: 100,
            labels: {
              formatter: (val) => {
                return val + '%'
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Three Measures in React

Using ApexCharts with React

This Three Measures example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: '2021',
        data: [
          {
            x: 'Unit tests',
            y: 62,
          },
          {
            x: 'Linting',
            y: 55,
          },
          {
            x: 'Type checks',
            y: 31,
          },
          {
            x: 'E2E tests',
            y: 24,
          },
          {
            x: 'Security scan',
            y: 18,
          },
        ],
      },
      {
        name: '2023',
        data: [
          {
            x: 'Unit tests',
            y: 74,
          },
          {
            x: 'Linting',
            y: 71,
          },
          {
            x: 'Type checks',
            y: 52,
          },
          {
            x: 'E2E tests',
            y: 39,
          },
          {
            x: 'Security scan',
            y: 37,
          },
        ],
      },
      {
        name: '2025',
        data: [
          {
            x: 'Unit tests',
            y: 88,
          },
          {
            x: 'Linting',
            y: 86,
          },
          {
            x: 'Type checks',
            y: 78,
          },
          {
            x: 'E2E tests',
            y: 58,
          },
          {
            x: 'Security scan',
            y: 64,
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'dumbbell',
        height: 380,
      },
      colors: ['#93C5FD', '#3B82F6', '#1D4ED8'],
      title: {
        text: 'Share of teams running each stage in CI',
        align: 'left',
      },
      subtitle: {
        text: 'Three snapshots on one row. Only the two extremes are labelled.',
        align: 'left',
      },
      plotOptions: {
        bar: {
          dumbbell: {
            connector: {
              color: '#E5E7EB',
              opacity: 1,
            },
            dataLabels: {
              formatter: function (val) {
                return val + '%'
              },
            },
          },
        },
      },
      xaxis: {
        min: 0,
        max: 100,
        labels: {
          formatter: function (val) {
            return val + '%'
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="dumbbell"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart